# Copyright (c) 2000-2004 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
"""
unittest for visitors.diadefs and extensions.diadefslib modules
"""

__revision__ = "$Id: unittest_vcg.py,v 1.4 2004/02/17 07:39:46 syt Exp $"

import unittest

from logilab.pyreverse.visitors.inspector import Linker
from logilab.pyreverse.extensions.diadefslib import DefaultDiadefGenerator
from logilab.pyreverse.extensions.diagrams import set_counter
from logilab.pyreverse.extensions.vcgutils import VCGWriter
from utils import FileTC, build_file_case, get_project, suite

project = get_project('data')
linker = Linker(project)
set_counter(0)
dd = DefaultDiadefGenerator(linker).visit(project)
for diagram in dd:
    diagram.extract_relationships()            

class VCGWriterTC(FileTC):

    generated_files = (#'No name package diagram'.replace(' ', '_') + '.vcg',
                       'classes_No_Name.vcg',)
    def do_run(self):
        writer = VCGWriter()
        writer.write(project, dd)
build_file_case(VCGWriterTC)

suite = suite(__name__)
def Run(runner=None):
    """run tests"""
    if runner is None:
        runner = unittest.TextTestRunner()
        # uncomment next line to write tests results in a file
        #runner.__init__(open('tests.log','w+'))    
    return runner.run(suite)

if __name__ == '__main__':
    Run()
